% EV3 Controller Parameters 
% (C) MathWorks, Inc., 2014
% Servo Gain Calculation using Optimal Regulator
A_BAR = [A1, zeros(4, 1); C1(1, :), 0];
B_BAR = [B1; 0, 0];

QQ = [
	1, 0,   0, 0, 0
	0, 6e5, 0, 0, 0
	0, 0,   1, 0, 0
	0, 0,   0, 1, 0
	0, 0,   0, 0, 4e2
	];                          % Q Matrix 
RR = 1e3 * eye(2);              % R Matrix 

% KK = lqr(A_BAR, B_BAR, QQ, RR); % LQR Control Algorithm
Ts = 0.004;
KD = lqrd(A_BAR, B_BAR, QQ, RR, Ts); % Discrete LQR Control Algorithm
k_f = KD(1, 1:4);				% feedback gain
k_i = KD(1, 5);					% integral gain

% % Reduce theta_dot gain... if robot shakes. 
% k_f(3) = k_f(3) * 0.85;

% Note: The gain on phi has been obtained experimentally
K = [k_i k_f -10 ;
     k_i k_f  10 ];

clear QQ RR